.intel_syntax noprefix
.data
	#alociramo memoriju od 8B i inicijalizujemo je vrednoscu 44
	x: .quad 44
.text
.global f

f:
	enter 0, 0

	#stavljamo na stek vrednost 13 zapisanu na 8B
	push qword ptr 13
	
	#UPUTSTVO: odkomentarisati svaki put samo po jednu od
	#sledecih varijanti i izvrsavanjem programa pratiti
	#kako se menjaju povratne vrednosti funkcije

	#I varijanta: kao povratnu vrednost funkcije vracamo
        #sadrzaj registra rsp, a to je adresa vrha steka
	#mov rax, rsp

	#II varijanta: kao povratnu vrednost funkcije vracamo
	#sadrzaj na adresi cija je vrednost smestena u rsp 
	#registru, a to je vrednost upisana na vrhu steka (13)
	#mov rax, [rsp]

	#III varijanta: kao povratnu vrednost funkcije pokusavamo
	#da vratimo adresu vrha steka, tj. sadrzaj registra rsp,
	#ali to nije sintaksno dozvoljeno jer drugi operand lea
	#instrukcije mora biti memorijski, a ne registarski
	#lea rax, rsp

	#IV varijanta: kao povratnu vrednost funkcije vracamo 
	#adresu vrha steka, tj. sadrzaj registra rsp
	#lea rax, [rsp]

	#V varijanta: kao povratnu vrednost funkcije vracamo
	#sadrzaj na adresi cija je vrednost zapamcena labelom x
	#mov rax, x

	#VI varijanta: kao povratnu vrednost funkcije vracamo
	#sadrzaj na adresi cija je vrednost zapamcena labelom x;
	#dodavanje uglastih zagrada na operand koji je vec po 
	#tipu memorijski nema nikakvog efekta
	#mov rax, [x]
	
	#VII varijanta: kao povratnu vrednost funkcije vracamo 
	#adresu koju cuva labela x
	#lea rax, x

	#VIII varijanta: kao povratnu vrednost funkcije vracamo 
	#adresu koju cuva labela x; dodavanje uglastih zagrada 
	#na operand koji je vec po tipu memorijski nema nikakvog
	#efekta
	#lea rax, [x]

	leave
	ret
