.intel_syntax noprefix
.text
.global swap

#void swap(int*, int*);
#          rdi   rsi
#NAPOMENA: nezavisno od tipa podataka, pokazivaci (adrese) se 
#prosledjuju kao neoznaceni celobrojni brojevi zapisani na 8B!
swap:
	enter 0,0

	#NAPOMENA: sve asemblerske instrukcije dozvoljavaju da
	#najvise jedan od operanada bude memorijski, pa moramo 
	#da izvrsimo zamenu u 4 umesto u 3 instrukcije, tj. da
	#koristimo 2 pomocne promenljive (pomocnih registara 
	#ovde) umesto 1!
	mov ecx, [rdi]
	mov edx, [rsi]
	mov [rdi], edx
	mov [rsi], ecx

	leave
	ret



