.intel_syntax noprefix
.text
.global savrsen_stepen

savrsen_stepen:
	enter 0, 0

	#IDEJA:
	#if(n==1){
	#	m = 1;
	#	k = 2;
	#	return 1;
	#}
	#m = 2;
	#while(m <= n/2){
	#	k = 2;
	#	stepen = m^2;
	#	while(stepen < n){
	#		stepen = stepen*m;
	#		k++;
	#	}
	#	if(stepen == n)
	#		return 1;
	#	m++;
	#}
	#return 0;

	cmp edi, 1
	je granicni_slucaj

	#m = 2;
	mov [rsi], dword ptr 2
	
	#ecx = n/2
	mov ecx, edi
	shr ecx, 1

spoljasnja_petlja:
	#proveravamo uslov izlaska iz spoljasnje petlje
	cmp [rsi], ecx
	ja nije

	#spremamo se za mnozenje m sa m
	mov eax, [rsi]
	
	#moramo da sacuvamo sadrzaj registra rdx (&k) na steku
	#jer ce instrukcija mul izmeniti sadrzaj rdx-a
	push rdx

	mul dword ptr [rsi]

	#upisujemo rezultat mnozenja u r8d (stepen)
	mov r8d, eax

	#vracamo u rdx sacuvanu vrednost sa steka
	pop rdx

	#k = 2;
	mov [rdx], dword ptr 2

unutrasnja_petlja:
	#proveravamo uslov izlaska iz unutrasnje petlje pri cemu 
	#razlikujemo dva slucaja:
	# - kada je stepen=n
	# - kada je stepen>n
	cmp r8d, edi
	je jeste
	ja priprema_spoljasnja 	

	#spremamo se za mnozenje stepen sa m
	mov eax, r8d
	
	#moramo da sacuvamo sadrzaj registra rdx (&k) na steku
	#jer ce instrukcija mul izmeniti sadrzaj rdx-a
	push rdx

	mul dword ptr [rsi]

	#upisujemo rezultat mnozenja u r8d (stepen)
	mov r8d, eax

	#vracamo u rdx sacuvanu vrednost sa steka
	pop rdx

	#k++;
	inc dword ptr [rdx]

	jmp unutrasnja_petlja

priprema_spoljasnja:
	#m++;
	inc dword ptr [rsi]
	
	jmp spoljasnja_petlja

granicni_slucaj:
	#m = 1;
	mov [rsi], dword ptr 1

	#k = 2;
	mov [rdx], dword ptr 2

	jmp jeste

nije:
	xor eax, eax
	jmp kraj

jeste:
	mov eax, 1

kraj:
	leave
	ret
	
