.intel_syntax noprefix
.data
	str_jeste: .asciz "%u = %u ^ %u\n"
	str_nije: .asciz "Broj %u nije savrsen stepen!\n"
.text
.global savrsen_stepen

savrsen_stepen:
	enter 0, 0

	#IDEJA:
	#if(n==1){
	#	m = 1;
	#	k = 2;
	#	printf("%u = %u ^ %u\n", n, m, k);
	#	return;
	#}
	#ind = 0;
	#m = 2;
	#while(m <= n/2){
	#	k = 2;
	#	stepen = m^2;
	#	while(stepen < n){
	#		stepen = stepen*m;
	#		k++;
	#	}
	#	if(stepen == n){
	#		ind = 1;
	#		printf("%u = %u ^ %u\n", n, m, k);
	#	}
	#	m++;
	#}
	#if(ind == 0)
	#	printf("Broj %u nije savrsen stepen\n", n);
	#return;

	cmp edi, 1
	je granicni_slucaj

	#r11d = ind = 0
	xor r11d, r11d

	#esi = m = 2
	mov esi,  2
	
	#ecx = n/2
	mov ecx, edi
	shr ecx, 1

spoljasnja_petlja:
	#proveravamo uslov izlaska iz spoljasnje petlje
	cmp esi, ecx
	ja kraj

	#spremamo se za mnozenje m sa m
	mov eax, esi

	#moramo da sacuvamo sadrzaj registra rdx (edx=k) na
	#steku jer ce instrukcija mul izmeniti sadrzaj rdx-a
	push rdx

	mul esi

	#upisujemo rezultat mnozenja u r8d (stepen)
	mov r8d, eax

	#vracamo u rdx sacuvanu vrednost sa steka
	pop rdx

	#edx = k = 2
	mov edx, 2

unutrasnja_petlja:
	#proveravamo uslov izlaska iz unutrasnje petlje pri cemu 
	#razlikujemo dva slucaja:
	# - kada je stepen=n
	# - kada je stepen>n
	cmp r8d, edi
	je ispis
	ja priprema_spoljasnja 	

	#spremamo se za mnozenje stepen sa m
	mov eax, r8d
	
	#moramo da sacuvamo sadrzaj registra rdx (edx=k) na
	#steku jer ce instrukcija mul izmeniti sadrzaj rdx-a
	push rdx

	mul esi

	#upisujemo rezultat mnozenja u r8d (stepen)
	mov r8d, eax

	#vracamo u rdx sacuvanu vrednost sa steka
	pop rdx

	#k++;
	inc edx

	jmp unutrasnja_petlja

priprema_spoljasnja:
	#m++;
	inc esi
	
	jmp spoljasnja_petlja

ispis:
	#ind = 1
	mov r11d, 1

	#cuvamo na steku vrednosti svih registara koje koristimo
	#a cije vrednosti moze da nam izmeni funkcija printf
	push rdi
	push rsi
	push rdx
	push rcx
	push r8
	push r11

	#pripremamo argumente za poziv printf-a
	mov ecx, edx
	mov edx, esi
	mov esi, edi
	lea rdi, str_jeste

	mov rax, 0
	
	call printf

	#vracamo u registre sacuvane vrednosti sa steka
	pop r11
	pop r8
	pop rcx
	pop rdx
	pop rsi
	pop rdi

	jmp priprema_spoljasnja

granicni_slucaj:
	#pripremamo argumente za poziv printf-a
	mov ecx, 2
	mov edx, 1
	mov esi, edi
	lea rdi, str_jeste

	mov rax, 0
	
	call printf

	#NAPOMENA: ovde nismo cuvali pre poziva funkcije printf
	#vrednosti registara koje koristimo na steku zato sto nam
	#te vrednosti nece biti potrebne nakon poziva funkcije
	#printf - jer odmah zavrsavamo funkciju savrsen_stepen!

	jmp kraj

nije_ss:
	#pripremamo argumente za poziv printf-a
	mov esi, edi
	lea rdi, str_nije

	mov rax, 0
	
	call printf

kraj:
	cmp r11d, 0
	je nije_ss

	leave
	ret
	
